import java.util.ArrayList;

/**
 * XMLEncoder/Decoderでオブジェクトを永続化することを確認する例題．
 * あるオブジェクト(A)を永続化すれば，そこから参照されている永続化可能なオブジェクト(B)も永続化されていることが確認できる．
 */
public class Main {
	public static void main(String[] args) {
		// それぞれにオブジェクトをつくって，
		A a=new A("sakana");
		B b=new B("tako");
		C[] cary=new C[3];
		for(int i=0; i<cary.length; i++) cary[i]=new C("kani"+i);
		ArrayList<C> alist=new ArrayList<C>();
		for(int i=0; i<4; i++) alist.add(new C("ebi"+i));
		
		a.setRefB(b);
		a.setRefCary(cary);
		b.setAlist(alist);
		
		// 作成されていることを確認する．
		a.sayName();
		
		// aを永続化
		a.save("afo.xml");
		
		// 永続化したA型のオブジェクトをロード，参照は一応他の名前を使う
		A newa=A.load("afo.xml");
		
		// ロードされた中身の確認
		if(newa!=null) newa.sayName();
	}

}
